import java.util.LinkedList;

public class HelloWorld {
	
	public static void main(String[] args) {
		
		Person p1 = new Person("Bob");
        Person p2 = new Person();
        
        // person created from employee object type
        Person p3 = (Person) new Employee(200);
        p3.setName("Moe");
       
        // change the reference to an Employee instead
        Employee e1 = (Employee) p3;
        System.out.println(e1.getName() + " " + e1.getEmployeeID());
        
        p2.setName("Larry");
        System.out.println(p1.getName() + " " + p2.getName());
        
        // create more people
        
        Person p4 = new Person("ThingOne");
        Person p5 = new Person("ThingTwo");
        Person p6 = new Person("ThingThree");
        
        // uses java.util.LinkedList
        LinkedList<Person> myPeeps = new LinkedList<Person>();
        
        myPeeps.add(p1);
        myPeeps.add(p2);
        myPeeps.add(p3);
        myPeeps.addLast(p4);
        myPeeps.addFirst(p5);
        myPeeps.add(1, p6);
        
        // need to overload toString method of person to print names
        	System.out.println(myPeeps.toString());
        
        	 // set a value
            myPeeps.set(0, p1);
            System.out.println("Peeps after change: " + myPeeps);
            
        // get a value
            Person mySelectedPeep = myPeeps.get(3);
            System.out.println("3rd Peep is: " + mySelectedPeep.getName());
            
         // remove elements from the linked list
            myPeeps.remove(p2); // remove by item "Larry" is p2
            myPeeps.remove(2); //  or remove by position
            
            Person afterRemove = myPeeps.get(3);
            System.out.println("3rd Peep is now: " + afterRemove.getName());
            
            // Simple Stack
            LinkedList myInts = new LinkedList();
            
            for (int i=0; i<10; i++)
            {
               myInts.add(i);
            }
            // finished stack
        	    System.out.println(myInts);
        	    // remove 1 item
        	    myInts.removeLast(); // LIFO
        	    // the new list -1
        	    System.out.println("New List: " + myInts);
            
        	    
            // Simple Queue
            LinkedList moreInts = new LinkedList();
            
            for (int i=10; i<20; i++)
            {
               moreInts.add(i);
            }
            System.out.println(moreInts);
            
            moreInts.removeFirst(); // FIFO
            // the new list -1
            System.out.println("New List: " + moreInts);
	}

}
